// EventHandler.cpp: implementation of the CEventHandler class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EventHandler.h"
#include "ETSerialPortViewer.h"
#include "ETSerialPortViewerDlg.h"
#include <comdef.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEventHandler::CEventHandler()
{
	m_pMain = NULL;
}

CEventHandler::~CEventHandler()
{
}

void CEventHandler::SetMainWindow(HWND hWnd)
{
	m_pMain = CWnd::FromHandle(hWnd);
}

//////////////////////////////////////////////////////////////////////
// Operation
//////////////////////////////////////////////////////////////////////


HRESULT __stdcall CEventHandler::Notify()
{
	if (m_pMain == NULL)
		return E_FAIL;

	LPSAFEARRAY* items = new LPSAFEARRAY; // we want a new location at each call
	long count;
	VARIANT_BOOL bAvailable;
	CComVariant value;
	long i=0;

	HRESULT hr = gpISerialOutPort->GetScaledData(items, &count, &bAvailable);

	if (FAILED(hr))
		return hr;

	if (bAvailable == VARIANT_TRUE)
	{
		m_pMain->PostMessage(WM_NEW_MSG, (WPARAM)items, count);
		// Note: message handler will perform the clean-up
	}
	else
	{
		// This is unlikely to happen - we only receive a callback when
		// bAvailable is true, but just in case
		delete items;
	}

	return S_OK;
}
