#include "stdafx.h"
#include "EyeFixationTrigger.h"
//#include <iostream>
//#include <deque>


using namespace std;  // std c++ libs implemented in std



// typedef deque<int, allocator<int> >  INTDEQUE;

// void print_contents (INTDEQUE  deque);


EyeFixationTrigger::EyeFixationTrigger(int fix_duration)
{
	eye_pos_sum = 0;
	eye_pos_mean = 0;
	eye_pos_std_dev = 0;
	sampling_rate = 60;
	eye_track_pos_samples = (int)(fix_duration * sampling_rate/1000.0);

}

EyeFixationTrigger::~EyeFixationTrigger(void)
{
}

bool EyeFixationTrigger::Add_Eye_Pos(double pos)
{
    double temp = 0;

	if(eye_pos.size( ) < eye_track_pos_samples)
	{
		eye_pos.push_back(pos);
		eye_pos_sum = eye_pos_sum + pos;
		eye_pos_mean = eye_pos_sum / eye_pos.size( );

		//calculate standard deviation for the list
		double eye_pos_std_dev_tmp = 0;
		 for( int i = 0; i < eye_pos.size(); i++ )
		 {
           eye_pos_std_dev_tmp = eye_pos_std_dev_tmp + (eye_pos[i] - eye_pos_mean)*(eye_pos[i] - eye_pos_mean);
		 }
          
		 eye_pos_std_dev = sqrt(eye_pos_std_dev_tmp/eye_pos.size( ));

		 return false;
	}
	else
	{
		// Get the value of the oldest element in the eye-position list
		double& first_pos = eye_pos.front(); 

		//Substruct the values of the first element from the sum
        eye_pos_sum = eye_pos_sum - first_pos;

		//Remove the first element from the eye_pos list
		eye_pos.pop_front();

		//add the new element to the end of the eye_pos list
		eye_pos.push_back(pos);

		//add the new element to the sum
        eye_pos_sum = eye_pos_sum + pos;
        
		//calculate the mean for the list of eye_pos values
		eye_pos_mean= eye_pos_sum / eye_pos.size( );

		//calculate standard deviation for the list
		double eye_pos_std_dev_tmp = 0;

		for( int i = 0; i < eye_pos.size(); i++ )
		{
          eye_pos_std_dev_tmp = eye_pos_std_dev_tmp + (eye_pos[i] - eye_pos_mean)*(eye_pos[i] - eye_pos_mean);
		}
          
		eye_pos_std_dev = sqrt(eye_pos_std_dev_tmp/eye_pos.size( ));
		cout << "Dev:" << eye_pos_std_dev << endl;



		if(eye_pos_std_dev <= 1.5)
		{
			eye_pos_sum = 0;
	        eye_pos_mean = 0;
	        eye_pos_std_dev = 0;
			eye_pos.clear();
			return true;
		}
		else
		{
			return false;
		}

	}

}
