#pragma once

#include <iostream>
#include <deque>
#include <cmath>

using namespace std;

class EyeFixationTrigger
{
public:
	EyeFixationTrigger(int fix_duration);
	~EyeFixationTrigger(void);

	//This function will add the eye position to the list
	bool Add_Eye_Pos(double pos);

	//the list of the eye-positions to examine
	deque<double> eye_pos;

	//stores the sum of the elements
	double eye_pos_sum;

	//stores eye pos list mean
	double eye_pos_mean;

	//stores eye pos list standard deviation
	double eye_pos_std_dev;

	//sampling rate of the eye-tracker - samples per second (actually how fast eye-tracking
	//samples are arriving to the interface)
	int sampling_rate;

	//the number of the eye-tracking samples for triggering event
	int eye_track_pos_samples;
};
